#!/bin/bash

#a recursive function that performs an exact dichotomy
# $1 is the value to split
# $2 is the number of processing resources
function partition () {
  if (( $1 < 1 )); then
    echo "error ! \$1 < 1 !"
  else
    if (( $2 < 1 )); then
      echo "error ! \$2 < 1 !"
    else
      local a=0;   # sink counter
      local c=0;   # accumulator
      local d=$(($1 / $2))  # dividend
      local e=$(($1  %$2))  # modulo
      while :; do
        local b=$d  # adjusted dividend
        [ "$e" -ne "0" ] && {
          e=$((e-1))
          b=$((b+1))
        }
        local f=$((c+b))
        echo "run #$a, length=$b, from $c to $f"
        echo "./scan $c $f log$WIDTH.$a.p7k &"
        nice  ./scan $c $f log$WIDTH.$a.p7k &
        a=$((a+1))
        c=$f
        [ "$a" -eq "$2" ] && break
      done
    fi;
  fi;
}

CORES=4
WIDTH=18
SIZE=$(( 2 ** $WIDTH ))
gcc -Wall -Os -DWIDTH=$WIDTH scan_1x_06.c -o scan
partition $SIZE $CORES
